"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildAndDeployApi = exports.buildApi = exports.runCLI = exports.stopTestEnvironment = exports.initTestEnvironment = exports.providers = exports.ensAddresses = void 0;
/* eslint-disable @typescript-eslint/naming-convention */
var generate_name_1 = require("./generate-name");
var path_1 = __importDefault(require("path"));
var spawn_command_1 = __importDefault(require("spawn-command"));
var axios_1 = __importDefault(require("axios"));
var fs_1 = __importDefault(require("fs"));
var js_yaml_1 = __importDefault(require("js-yaml"));
var core_js_1 = require("@web3api/core-js");
var client_js_1 = require("@web3api/client-js");
var ethereum_plugin_js_1 = require("@web3api/ethereum-plugin-js");
exports.ensAddresses = {
    ensAddress: "0xe78A0F7E598Cc8b0Bb87894B0F60dD2a88d6a8Ab",
    resolverAddress: "0x5b1869D9A4C187F2EAa108f3062412ecf0526b24",
    registrarAddress: "0xD833215cBcc3f914bD1C9ece3EE7BF8B14f841bb",
    reverseAddress: "0xe982E462b094850F12AF94d21D470e21bE9D0E9C",
};
exports.providers = {
    ipfs: "http://localhost:5001",
    ethereum: "http://localhost:8545",
};
var monorepoCli = __dirname + "/../../../cli/bin/w3";
var npmCli = __dirname + "/../../cli/bin/w3";
function awaitResponse(url, expectedRes, getPost, timeout, maxTimeout, data) {
    return __awaiter(this, void 0, void 0, function () {
        var time, request, success;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    time = 0;
                    _a.label = 1;
                case 1:
                    if (!(time < maxTimeout)) return [3 /*break*/, 4];
                    request = getPost === "get" ? axios_1.default.get(url) : axios_1.default.post(url, data);
                    return [4 /*yield*/, request
                            .then(function (response) {
                            var responseData = JSON.stringify(response.data);
                            return responseData.indexOf(expectedRes) > -1;
                        })
                            .catch(function () {
                            return false;
                        })];
                case 2:
                    success = _a.sent();
                    if (success) {
                        return [2 /*return*/, true];
                    }
                    return [4 /*yield*/, new Promise(function (resolve) {
                            setTimeout(function () { return resolve(); }, timeout);
                        })];
                case 3:
                    _a.sent();
                    time += timeout;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/, false];
            }
        });
    });
}
exports.initTestEnvironment = function (cli) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, exitCode, stderr, stdout, success;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, exports.runCLI({
                    args: ["infra", "up", "--modules=eth-ens-ipfs", "--verbose"],
                    cli: cli,
                })];
            case 1:
                _a = _b.sent(), exitCode = _a.exitCode, stderr = _a.stderr, stdout = _a.stdout;
                success = false;
                return [4 /*yield*/, awaitResponse("http://localhost:5001/api/v0/version", '"Version":', "get", 2000, 20000)];
            case 2:
                // IPFS
                success = _b.sent();
                if (!success) {
                    throw Error("test-env: IPFS failed to start");
                }
                return [4 /*yield*/, awaitResponse("http://localhost:8545", '"jsonrpc":', "post", 2000, 20000, '{"jsonrpc":"2.0","method":"eth_blockNumber","params":[],"id":83}')];
            case 3:
                // Ganache
                success = _b.sent();
                if (!success) {
                    throw Error("test-env: Ganache failed to start");
                }
                if (exitCode) {
                    throw Error("initTestEnvironment failed to start test environment.\nExit Code: " + exitCode + "\nStdErr: " + stderr + "\nStdOut: " + stdout);
                }
                // Wait an extra couple of seconds for the ens deployment to finish
                return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 3000); })];
            case 4:
                // Wait an extra couple of seconds for the ens deployment to finish
                _b.sent();
                return [2 /*return*/];
        }
    });
}); };
exports.stopTestEnvironment = function (cli) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, exitCode, stderr;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, exports.runCLI({
                    args: ["infra", "down", "--modules=eth-ens-ipfs"],
                    cli: cli,
                })];
            case 1:
                _a = _b.sent(), exitCode = _a.exitCode, stderr = _a.stderr;
                if (exitCode) {
                    throw Error("stopTestEnvironment failed to stop test environment.\nExit Code: " + exitCode + "\nStdErr: " + stderr);
                }
                return [2 /*return*/, Promise.resolve()];
        }
    });
}); };
exports.runCLI = function (options) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, exitCode, stdout, stderr;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve, reject) {
                    var _a, _b;
                    if (!options.cwd) {
                        // Make sure to set an absolute working directory
                        var cwd = process.cwd();
                        options.cwd = cwd[0] !== "/" ? path_1.default.resolve(__dirname, cwd) : cwd;
                    }
                    // Resolve the CLI
                    if (!options.cli) {
                        if (fs_1.default.existsSync(monorepoCli)) {
                            options.cli = monorepoCli;
                        }
                        else if (fs_1.default.existsSync(npmCli)) {
                            options.cli = npmCli;
                        }
                        else {
                            throw Error("runCli is missing a valid CLI path, please provide one");
                        }
                    }
                    var command = "node " + options.cli + " " + options.args.join(" ");
                    var child = spawn_command_1.default(command, { cwd: options.cwd, env: options.env });
                    var stdout = "";
                    var stderr = "";
                    child.on("error", function (error) {
                        reject(error);
                    });
                    (_a = child.stdout) === null || _a === void 0 ? void 0 : _a.on("data", function (data) {
                        stdout += data.toString();
                    });
                    (_b = child.stderr) === null || _b === void 0 ? void 0 : _b.on("data", function (data) {
                        stderr += data.toString();
                    });
                    child.on("exit", function (exitCode) {
                        resolve([exitCode, stdout, stderr]);
                    });
                })];
            case 1:
                _a = __read.apply(void 0, [_b.sent(), 3]), exitCode = _a[0], stdout = _a[1], stderr = _a[2];
                return [2 /*return*/, {
                        exitCode: exitCode,
                        stdout: stdout,
                        stderr: stderr,
                    }];
        }
    });
}); };
function buildApi(apiAbsPath) {
    return __awaiter(this, void 0, void 0, function () {
        var manifestPath, _a, buildExitCode, buildStdout, buildStderr;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    manifestPath = apiAbsPath + "/web3api.yaml";
                    return [4 /*yield*/, exports.runCLI({
                            args: [
                                "build",
                                "--manifest-file",
                                manifestPath,
                                "--output-dir",
                                apiAbsPath + "/build",
                            ],
                        })];
                case 1:
                    _a = _b.sent(), buildExitCode = _a.exitCode, buildStdout = _a.stdout, buildStderr = _a.stderr;
                    if (buildExitCode !== 0) {
                        console.error("w3 exited with code: " + buildExitCode);
                        console.log("stderr:\n" + buildStderr);
                        console.log("stdout:\n" + buildStdout);
                        throw Error("w3 CLI failed");
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.buildApi = buildApi;
function buildAndDeployApi(_a) {
    var apiAbsPath = _a.apiAbsPath, ipfsProvider = _a.ipfsProvider, ethereumProvider = _a.ethereumProvider, ensName = _a.ensName;
    return __awaiter(this, void 0, void 0, function () {
        var manifestPath, tempManifestFilename, tempDeployManifestFilename, tempManifestPath, tempDeployManifestPath, apiEns, ensWrapperUri, ethereumPluginUri, client, signerAddress, _b, registerData, error, _c, __type, web3apiManifest, _d, deployExitCode, deployStdout, deployStderr, extractCID, result, apiCid;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    manifestPath = apiAbsPath + "/web3api.yaml";
                    tempManifestFilename = "web3api-temp.yaml";
                    tempDeployManifestFilename = "web3api.deploy-temp.yaml";
                    tempManifestPath = path_1.default.join(apiAbsPath, tempManifestFilename);
                    tempDeployManifestPath = path_1.default.join(apiAbsPath, tempDeployManifestFilename);
                    apiEns = ensName !== null && ensName !== void 0 ? ensName : generate_name_1.generateName() + ".eth";
                    return [4 /*yield*/, buildApi(apiAbsPath)];
                case 1:
                    _e.sent();
                    ensWrapperUri = "fs/" + __dirname + "/wrappers/ens";
                    ethereumPluginUri = "w3://ens/ethereum.web3api.eth";
                    client = new client_js_1.Web3ApiClient({
                        plugins: [
                            {
                                uri: ethereumPluginUri,
                                plugin: ethereum_plugin_js_1.ethereumPlugin({
                                    networks: {
                                        testnet: {
                                            provider: ethereumProvider,
                                        },
                                    },
                                    defaultNetwork: "testnet",
                                }),
                            },
                        ],
                    });
                    return [4 /*yield*/, client.invoke({
                            method: "getSignerAddress",
                            module: "query",
                            uri: ethereumPluginUri,
                            input: {
                                connection: {
                                    networkNameOrChainId: "testnet",
                                },
                            },
                        })];
                case 2:
                    signerAddress = (_e.sent()).data;
                    if (!signerAddress) {
                        throw new Error("Could not get signer");
                    }
                    return [4 /*yield*/, client.invoke({
                            method: "registerDomainAndSubdomainsRecursively",
                            module: "mutation",
                            uri: ensWrapperUri,
                            input: {
                                domain: apiEns,
                                owner: signerAddress,
                                resolverAddress: exports.ensAddresses.resolverAddress,
                                ttl: "0",
                                registrarAddress: exports.ensAddresses.registrarAddress,
                                registryAddress: exports.ensAddresses.ensAddress,
                                connection: {
                                    networkNameOrChainId: "testnet",
                                },
                            },
                        })];
                case 3:
                    _b = _e.sent(), registerData = _b.data, error = _b.error;
                    if (!registerData) {
                        throw new Error("Could not register domain '" + apiEns + "'" +
                            (error ? "\nError: " + error.message : ""));
                    }
                    return [4 /*yield*/, client.invoke({
                            method: "awaitTransaction",
                            module: "query",
                            uri: ethereumPluginUri,
                            input: {
                                txHash: registerData.hash,
                                confirmations: 1,
                                timeout: 15000,
                                connection: {
                                    networkNameOrChainId: "testnet",
                                },
                            },
                        })];
                case 4:
                    _e.sent();
                    _c = core_js_1.deserializeWeb3ApiManifest(fs_1.default.readFileSync(manifestPath, "utf-8")), __type = _c.__type, web3apiManifest = __rest(_c, ["__type"]);
                    fs_1.default.writeFileSync(tempManifestPath, js_yaml_1.default.dump(__assign(__assign({}, web3apiManifest), { format: "0.0.1-prealpha.8", deploy: "./" + tempDeployManifestFilename })));
                    fs_1.default.writeFileSync(tempDeployManifestPath, js_yaml_1.default.dump({
                        format: "0.0.1-prealpha.1",
                        stages: {
                            ipfsDeploy: {
                                package: "ipfs",
                                uri: "fs/" + apiAbsPath + "/build",
                                config: {
                                    gatewayUri: ipfsProvider,
                                },
                            },
                            ensPublish: {
                                package: "ens",
                                // eslint-disable-next-line @typescript-eslint/naming-convention
                                depends_on: "ipfsDeploy",
                                config: {
                                    domainName: apiEns,
                                    provider: ethereumProvider,
                                    ensRegistryAddress: exports.ensAddresses.ensAddress,
                                },
                            },
                        },
                    }));
                    return [4 /*yield*/, exports.runCLI({
                            args: ["deploy", "--manifest-file", tempManifestPath],
                        })];
                case 5:
                    _d = _e.sent(), deployExitCode = _d.exitCode, deployStdout = _d.stdout, deployStderr = _d.stderr;
                    if (deployExitCode !== 0) {
                        console.error("w3 exited with code: " + deployExitCode);
                        console.log("stderr:\n" + deployStderr);
                        console.log("stdout:\n" + deployStdout);
                        throw Error("w3 CLI failed");
                    }
                    // remove manually configured manifests
                    fs_1.default.unlinkSync(tempManifestPath);
                    fs_1.default.unlinkSync(tempDeployManifestPath);
                    extractCID = /(w3:\/\/ipfs\/[A-Za-z0-9]+)/;
                    result = deployStdout.match(extractCID);
                    if (!result) {
                        throw Error("W3 CLI output missing IPFS CID.\nOutput: " + deployStdout);
                    }
                    apiCid = new core_js_1.Uri(result[1]).path;
                    return [2 /*return*/, {
                            ensDomain: apiEns,
                            ipfsCid: apiCid,
                        }];
            }
        });
    });
}
exports.buildAndDeployApi = buildAndDeployApi;
//# sourceMappingURL=index.js.map